// FwCmdLineParser.cpp: implementation of the CFwCmdLineParser class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FwCmdLineParser.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/*!
	Default constructor initialises all internal variables and parses
	the command line.
*/
CFwCmdLineParser::CFwCmdLineParser()
{
	int nKey=0;
	CString csKey,csValue;

	for (int i=1; i<__argc; i++) {
		if (*__argv[i]=='-' || *__argv[i]=='/') {
			m_csKeys.Add(__argv[i]+1);
			m_csValues.Add(_T(""));
			if (i+1<__argc) {
				if (*__argv[i+1]!='-' && *__argv[i+1]!='/') {
					m_csValues[nKey]=__argv[i+1];
					i++;
				}
			}
			nKey++;
		} else {
			m_csValues.Add(__argv[i]);
			m_csKeys.Add(_T(""));
			nKey++;
		}
	}
}

/*!
	Default constructor frees all resources used by object.
*/
CFwCmdLineParser::~CFwCmdLineParser()
{

}

/*!
	Returns the command line of application.
*/
LPCTSTR CFwCmdLineParser::GetCmdLine()
{
	return GetCommandLine();
}

/*!
	GetArg() method is used to chack the presence of the parameter
	specified by szKey. If pcsValue if not NULL, the call of this 
	member will store value to pcsValue. This member is case-sensitive.

	Returns TRUE if szKey is found in parameter list, otherwise FALSE.
*/
BOOL CFwCmdLineParser::GetArg(LPCTSTR szKey, CString *pcsValue)
{
	for (int i=0; i<m_csKeys.GetSize(); i++) {
		if (m_csKeys[i].Compare(szKey)==0) {
			if (pcsValue) *pcsValue=m_csValues[i];
			return TRUE;
		}
	}
	return FALSE;
}

/*!
	GetArgNoCase() method is used to chack the presence of the parameter
	specified by szKey. If pcsValue if not NULL, the call of this 
	member will store value to pcsValue. This member is case-insensitive.

	Returns TRUE if szKey is found in parameter list, otherwise FALSE.
*/
BOOL CFwCmdLineParser::GetArgNoCase(LPCTSTR szKey, CString *pcsValue)
{
	for (int i=0; i<m_csKeys.GetSize(); i++) {
		if (m_csKeys[i].CompareNoCase(szKey)==0) {
			if (pcsValue) *pcsValue=m_csValues[i];
			return TRUE;
		}
	}
	return FALSE;
}

/*!
	GetAtKey() returns key by zero-based index from parameters 
	list.
*/
CString CFwCmdLineParser::GetAtKey(int nIndex)
{
	return m_csKeys[nIndex];
}

/*!
	GetAtKey() returns value by zero-based index from parameters 
	list.
*/
CString CFwCmdLineParser::GetAtValue(int nIndex)
{
	return m_csValues[nIndex];
}

/*!
	GetAtKey() returns parameters count. The parameter
	count of keys and values is the same. If key was not
	specified, key assumed "".
*/
int CFwCmdLineParser::GetCount()
{
	return (int)m_csKeys.GetSize();
}
