// FwCmdLineParser.h: interface for the CFwCmdLineParser class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FWCMMANDLINEPARSER_H__45B09429_DBEC_4652_832F_3814B2F338D2__INCLUDED_)
#define AFX_FWCMMANDLINEPARSER_H__45B09429_DBEC_4652_832F_3814B2F338D2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/*! \ingroup Process
	\class CFwCmdLineParser"
    \brief Command line parameters parser.
*/
class CFwCmdLineParser  
{
public:
	//! Get parameter count
	int GetCount();			

	//! Get key by index
	CString GetAtKey(int nIndex);

	//! Get value by index
	CString GetAtValue(int nIndex);

	//! Get get parameter value by key (case senetive)
	BOOL GetArg(LPCTSTR szKey,CString *pcsValue=NULL);

	//! Get get parameter value by key (case insenetive)
	BOOL GetArgNoCase(LPCTSTR szKey,CString *pcsValue=NULL);

	//! Get the whole command line
	LPCTSTR GetCmdLine();

	//! Default constructor
	CFwCmdLineParser();

	//! Default destructor
	virtual ~CFwCmdLineParser();

protected:
	CStringArray m_csKeys;
	CStringArray m_csValues;
};

#endif // !defined(AFX_FWCMMANDLINEPARSER_H__45B09429_DBEC_4652_832F_3814B2F338D2__INCLUDED_)
