// vcclean.cpp :      VC8.
//

#include "stdafx.h"
#include "vcclean.h"
#include "FwCmdLineParser.h"
#include <shlwapi.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// The one and only application object

CWinApp theApp;

using namespace std;

BOOL ProcessDirectory(LPCTSTR szDirPath);

BOOL g_bIncludeExe=FALSE;
BOOL g_bTrueDelete=FALSE;


//     
BOOL DirWalk(LPCSTR szPath)
{
	return FALSE;
}


int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	const char *szcHelp="help";
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		return 1;
	}

	CFwCmdLineParser params;

	try {
		if (argc<2) throw 0;
		else
		{
			CString csDir(argv[1]);
			if (!PathIsDirectory(csDir)) throw 0;
			printf("Processing directory '%s'\n",csDir);
			SetCurrentDirectory(csDir);
		}
		
		if (params.GetArgNoCase(_T("?"))) throw szcHelp;
		if (params.GetArgNoCase(_T("h"))) throw szcHelp;
		if (params.GetArgNoCase(_T("help"))) throw szcHelp;
		if (params.GetArgNoCase(_T("re"))) {
			g_bIncludeExe=TRUE;
		}
		if (params.GetArgNoCase(_T("d"))) {
			g_bTrueDelete=TRUE;
		}
	} catch (...) {
		printf("Utility to remove all remporery files in all subfolders\n");
		printf("\n");
		printf("Usage: vcclean <dir> [switches]\n");
		printf("\n");
		printf("		<dir>	directory name to process (or '.')\n");
		printf("\n");
		printf("Switches:\n");
		printf("\n");
		printf("       -?              -  display help\n");
		printf("       -h              -  display help\n");
		printf("       -help           -  display help\n");
		printf("       -re             -  also remove exe-files\n");
		printf("       -d              -  true remove (not to Recycle Bin)\n");
		printf("\n");
		return 0;
	}

	CHAR szCurDir[MAX_PATH+1];
	if (GetCurrentDirectory(MAX_PATH,szCurDir)) {
		ProcessDirectory(szCurDir);
	} else {
		printf("Error reading current directory!\n");
	}

	return 0;
}


BOOL ProcessDirectory(LPCTSTR szDirPath)
{
	WIN32_FIND_DATA fData;
	
	HANDLE hDir=FindFirstFileEx(szDirPath+CString(_T("\\*")),FindExInfoStandard,&fData,
		FindExSearchLimitToDirectories,NULL,0);

	if (hDir!=INVALID_HANDLE_VALUE) {
		do {
			CString csFullPath=szDirPath+CString(_T("\\"))+CString(fData.cFileName);

			// recoursive walk over directories
			if ((fData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
				if (StrCmp(fData.cFileName,_T(".")) && 
					StrCmp(fData.cFileName,_T(".."))) {

					printf("Processing directory '%s'\n",fData.cFileName);
					ProcessDirectory(csFullPath);
				}
			} else {
				BOOL bRemove=FALSE;
				LPTSTR szExt=PathFindExtension(csFullPath);
				if (szExt) {
					if (StrCmpI(szExt,".idb")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".ilk")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".obj")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".pdb")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".res")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".pch")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".aps")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".ncb")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".plg")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".pcc")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".exp")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".sbr")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".log")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".tmp")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".dep")==0) bRemove=TRUE;
					if (StrCmpI(szExt,".bsc")==0) bRemove=TRUE;
					//if (StrCmpI(szExt,".user")==0) bRemove=TRUE;

					if (StrStrI(fData.cFileName,"BuildLog.htm")) bRemove=TRUE;
					if (StrStrI(fData.cFileName,".exe.embed.manifest")) bRemove=TRUE;
					if (StrStrI(fData.cFileName,".exe.intermediate.manifest")) bRemove=TRUE;

					if (g_bIncludeExe) {
						if (StrCmpI(szExt,".exe")==0) bRemove=TRUE;
						if (StrCmpI(szExt,".lib")==0) bRemove=TRUE;
						if (StrCmpI(szExt,".ocx")==0) bRemove=TRUE;
						if (StrCmpI(szExt,".dll")==0) bRemove=TRUE;
						if (StrCmpI(szExt,".tlb")==0) bRemove=TRUE;
					}
				}

				if (bRemove) {
					// process all temporary files
					printf("Deleting file '%s' done\n",csFullPath);


					if (g_bTrueDelete) {
						DeleteFile(csFullPath);
					} else {
						LPSTR pName=csFullPath.GetBuffer(MAX_PATH+1);
						pName[csFullPath.GetLength()+1]=0;

						SHFILEOPSTRUCT shfo;
						shfo.hwnd=NULL;
						shfo.wFunc=FO_DELETE;
						shfo.pFrom=csFullPath;
						shfo.pTo=NULL;
						shfo.fFlags=FOF_FILESONLY|FOF_NORECURSION|FOF_NOCONFIRMATION|FOF_NOERRORUI|FOF_SILENT|FOF_ALLOWUNDO;
						shfo.lpszProgressTitle=NULL;
						int ii=SHFileOperation(&shfo);
						csFullPath.ReleaseBuffer();
					}

				}

			}
		} while (FindNextFile(hDir,&fData));
	} else {
		return FALSE;
	}

	FindClose(hDir);

	return TRUE;
}


